/*$$$ 
<filter id="saturationShader" label="$$$/Shader/Saturation=Saturation" category="adjustment" vartype="intensity">
	<var varname="intensity" label="$$$/Shader/Saturation=Saturation" type="number" numFactor="100" min="-1" max="1" default="0" />
</filter>
$$$*/

precision highp float;

uniform sampler2D tt_uniform_maintexture;

uniform float intensity;

varying vec2 mainTexCoord;

void main()
{
	vec4 dst;
	
	vec4 curCol;
	vec4 srcCol;
	
	float skinFactor;
	float curVal;
	float factor;
	
	srcCol = texture2D(tt_uniform_maintexture, mainTexCoord.xy);
	
	SHIFTCOMPS(srcCol)
	
	curCol = srcCol;
	
	skinFactor = 1.0 - max(curCol.r - (curCol.g+curCol.b)/2.0,0.0);
	skinFactor *= skinFactor;
	
	factor = step(0.0,-intensity);
	skinFactor = factor + skinFactor*(1.0-factor);
	
	float dIntens = -intensity;
	float intens = intensity + 1.0;
	float matA = dIntens*0.299;
	float matB = dIntens*0.587;
	float matC = dIntens*0.114;
	
	mat3 satMatr;
	
	satMatr[0][0] = matA + intens;
	satMatr[0][1] = matA;
	satMatr[0][2] = matA;
	
	satMatr[1][0] = matB;
	satMatr[1][1] = matB + intens;
	satMatr[1][2] = matB;
	
	satMatr[2][0] = matC;
	satMatr[2][1] = matC;
	satMatr[2][2] = matC + intens;

	/*
	mat3 satMatr = mat3( vec3(matA + intens, matA, matA),
								vec3(matB, matB + intens, matB),
								vec3(matC, matC, matC + intens) );
	
	*/
	curCol.rgb = satMatr * srcCol.rgb;
	
	dst.xyz = mix(srcCol.xyz,curCol.xyz,skinFactor);
	dst.xyz = min(dst.xyz,srcCol.w);
	dst.w = srcCol.w;
	
	SHIFTCOMPS(dst)
	
	gl_FragColor = dst;
}
