/*$$$ 
<filter id="sizeShader" label="Size" category="adjustment" vartype="custom">
	<var varname="type" label="Type" type="number" min="0" max="1" default="0" />
</filter>
$$$*/

precision highp float;

uniform sampler2D tt_uniform_maintexture;

uniform vec2 tt_uniform_pixelsize;

uniform float type;

varying vec2 mainTexCoord;

void main()
{
	vec2 curCoord;
	lowp vec4 curCol;
	lowp vec4 minCol;
	lowp vec4 maxCol;
	
	curCoord.x = mainTexCoord.x - tt_uniform_pixelsize.x;
	curCoord.y = mainTexCoord.y;
	minCol = maxCol = texture2D(tt_uniform_maintexture, curCoord);
	
	curCoord.x = mainTexCoord.x + tt_uniform_pixelsize.x;
	curCol = texture2D(tt_uniform_maintexture, curCoord);
	maxCol = max(curCol,maxCol);
	minCol = min(curCol,minCol);
		
	curCoord.x = mainTexCoord.x;
	curCoord.y = mainTexCoord.y - tt_uniform_pixelsize.y;
	curCol = texture2D(tt_uniform_maintexture, curCoord);
	maxCol = max(curCol,maxCol);
	minCol = min(curCol,minCol);
		
	curCoord.y = mainTexCoord.y + tt_uniform_pixelsize.y;
	curCol = texture2D(tt_uniform_maintexture, curCoord);
	maxCol = max(curCol,maxCol);
	minCol = min(curCol,minCol);
	  
	gl_FragColor = mix(maxCol,minCol,type);
}
